> For the complete documentation index, see [llms.txt](https://docs.yemreak.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.yemreak.com/arsiv/programming/yt-dlp-ve-ffmpeg-kullanarak-typescript-ile-video-indirme-methodu.md).

# yt-dlp ve ffmpeg kullanarak typescript ile video indirme methodu

```javascript
npm i fluent-ffmpeg yt-dlp-wrap
```

```typescript
import ffmpeg from "fluent-ffmpeg"
import fs from "node:fs"
import YTDlpWrap from "yt-dlp-wrap"

const ffmpegPath = require("@ffmpeg-installer/ffmpeg").path
ffmpeg.setFfmpegPath(ffmpegPath) // to extract audio

export async function downloadVideoViaYtDlp(params: {
	url: string
	dirpath: string
	ytDlpPath: string
	download?: boolean
	login?: { username: string; password: string }
	cookieFilePath?: string
}): Promise<string> {
	const { url, dirpath, ytDlpPath, download = false } = params
	fs.mkdirSync(dirpath, { recursive: true })

	if (!fs.existsSync(ytDlpPath)) {
		if (!download) throw Error("yt-dlp not found and download is disabled")
		await YTDlpWrap.downloadFromGithub(ytDlpPath)
	}

	const cookieArg = []
	if (params.cookieFilePath) cookieArg.push("--cookies", params.cookieFilePath)
	else if (params.login)
		cookieArg.push("-u", params.login.username, "-p", params.login.password)

	const ytDlp = new YTDlpWrap(ytDlpPath)
	const info = await ytDlp.getVideoInfo([url, ...cookieArg])
	const filename = `${dirpath}/${info.filename}`
	if (fs.existsSync(filename)) {
		console.log(`Video already downloaded: "${filename}"`)
		return filename
	}

	await ytDlp.execPromise([
		url,
		"-f",
		"bestvideo[ext=mp4]+bestaudio[ext=m4a]/best[ext=mp4]/best",
		"--output",
		filename,
		...cookieArg,
	])
	return filename
}

```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.yemreak.com/arsiv/programming/yt-dlp-ve-ffmpeg-kullanarak-typescript-ile-video-indirme-methodu.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
